// slideshow.h
// for browsing through all coins and countries
// this was the first code I programmed in Qt,
// sorry, if it's chaotic...
// v0.84 (7.3.2002)
// (c) 2002 Andreas Krueger
//
// Please, if you change anything in this code,
// mark the end of those lines with '// *+* your name *+* ' 
// (so that I can find it) and send the code 
// to cye-code@AndreasKrueger.de
//
// last change: 4.5.2002
//          by: AndreasK

#ifndef SLIDESHOW_H
#define SLIDESHOW_H

#include "classes.h"
#include "constants.h"

#include <qmessagebox.h>
#include <qpixmap.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qvbox.h>
#include <qstring.h>
#include <qlcdnumber.h>
#include <qcolor.h>
#include <qpoint.h>

class SlideShow : public QVBox{
	Q_OBJECT
public:
	uint coin;
	uint country;
	QPixmap pics[NumCoins][NumCountries+1];
	QSize max_size;
	SlideShow(QWidget *parent=0, const char *name=0);
	void loadPictures(QString picfilepath, QString picfilesuffix, bool &dontShowLoadedPicsResults);
	//	QSizePolicy sizePolicy() const;
	void setPics(QPixmap pics[NumCoins][NumCountries+1], QSize theMaxSize);
	QPixmap centeredCoin(int coinnumber, int countrynumber);
	uint actualCoinNumber();
private:


//	QLabel *labelCoin;  
// 	QLabel *labelCountry;
	QPushButton *labelCoin;     // QPushButton, not QLabel
	QPushButton *labelCountry;  // so that clicked() events are triggered

	//QLCDNumber * LCDCoin;
	//QLCDNumber * LCDCountry;
	QLabel *labelCoinName;
	QLabel *labelCountryName;

private slots:
	void buttonNextCoinPressed();
	void buttonPreviousCoinPressed();
	void buttonNextCountryPressed();
	void buttonPreviousCountryPressed();
	void CoinPicturePressed();
	void CountryPicturePressed();
	
public slots:
	void nextCoin();
	void previousCoin();
	void nextCountry();
	void previousCountry();
	void switchToCoin(uint toCoin, uint toCountry);
	void switchToCoinNumber(uint CoinNumber);
	void changeCoinSide();
	void changeCountrySide();

signals:
	void CountryChanged();
	void CoinChanged();
	void focusChanged(uint coin, uint country);
	void Event(QString);
private:
	void DrawCoin(QPixmap *pix, QString countryname, QString coinname, 
						 QColor color1, QColor color2, QSize size, int radius1, int radius2);
	QColor RGB2Color(const unsigned char rgb[3]);
};


#endif // SLIDESHOW_H




